<!DOCTYPE html>
<html layout:decorate="~{fragments/layout}">

<head>
	<title>CATEGORY API</title>
</head>
<div layout:fragment="content">

	<body>
		<h1>INDEX API CATEGORY</h1>

		<div>
			<button onclick="openModal()" class="btn btn-primary">Create</button>
		</div>
		<div id="isiData"></div>


		<script>
			$(function () {
				getAllCategory()
			})
			function getAllCategory() {
				$.ajax({
					url: '/api/category',
					type: 'get',
					contentType: 'application/json',
					success: function (response) {
						listView(response)

					}
				})
			}
			function listView(response) {
				var str = '<table class="table table-hover table-striped" border="1">'
				str += '<thead class="thead-dark">'
				str += '<tr>'
				str += '<th class="text-center">No</th>'
				str += '<th class="text-center">Category Initial</th>'
				str += '<th class="text-center">Category Name</th>'
				str += '<th class="text-center">is Active</th>'
				str += '<th class="text-center" colspan="2">Action</th>'
				str += '</tr>'
				str += '</thead>'
				str += '<tbody>'
				for (var i = 0; i < response.length; i++) {
					str += '<tr>'
					str += '<td>' + (i + 1) + '</td>'
					str += '<td>' + response[i].categoryInitial + '</td>'
					str += '<td>' + response[i].categoryName + '</td>'
					var checked = response[i].isActive ? 'checked' : ''
					str += '<td><input type="checkbox" disabled ' + checked + '></td>'
					str += '<td><button class="btn btn-warning" value="' + response[i].id + '"onClick="f_edit(value)">Edit</button></td>'
					str += '<td><button class="btn btn-danger" value="' + response[i].id + '"onClick="f_delete(value)">Delete</button></td>'
					str += '</tr>'

				}

				str += '</tbody>'
				str += '</table>'


				$('#isiData').empty()
				$('#isiData').html(str)
			}

			function openModal() {
				var str = '<form>'
				str += '<div class="form-group">'
				str += '<label for="categoryInitial">Category Initial</label>'
				str += '<input type="text" class="form-control" id="categoryInitial">'
				str += '</div>'
				str += '<div class="form-group">'
				str += '<label for="categoryName">Category Name</label>'
				str += '<input type="text" class="form-control" id="categoryName">'
				str += '</div>'
				str += '<div class="form-group form-check">'
				str += '<input type="checkbox" class="form-check-input" id="isActive">'
				str += '<label for="isActive">Is Active</label>'
				str += '</div>'
				str += '</form>'

				$(".modal-title").html("form Category")
				$(".modal-body").html(str)
				$("#btnSave").html("Save Date")
				$("#btnSave").off('click').on("click", saveCategory)
				$("#modal").modal('show')
			}
			function saveCategory() {
				var formdata = '{'
				formdata += '"categoryInitial":"' + $("#categoryInitial").val() + '",'
				formdata += '"categoryName":"' + $("#categoryName").val() + '",'
				formdata += '"isActive":' + $("#isActive")[0].checked + ''
				formdata += '}'

				$.ajax({
					url: '/api/category/add',
					data: formdata,
					type: 'post',
					contentType: 'application/json',
					success: function () {
						$("#modal").modal('toggle')
						getAllCategory();
					}
				})
			}
			function f_edit(id) {
				$.ajax({
					url: '/api/category/' + id,
					type: 'get',
					contentType: 'application/json',
					success: function (category) {
						var str = '<form>'
						str += '<div class="form-group">'
						str += '<label for="categoryInitial">Category Initial</label>'
						str += '<input type="text" class="form-control" id="categoryInitial" value=" ' + category.categoryInitial + ' ">'
						str += '</div>'
						str += '<div class="form-group">'
						str += '<label for="categoryName">Category Name</label>'
						str += '<input type="text" class="form-control" id="categoryName" value=" ' + category.categoryName + '">'
						str += '</div>'
						str += '<div class="form-group form-check">'
						var checked = category.isActive ? 'checked' : ''
						str += '<input type="checkbox" class="form-check-input" id="isActive" ' + checked + ' >'
						str += '<label for="isActive">Is Active</label>'
						str += '</div>'
						str += '</form>'

						$(".modal-title").html("Edit Category")
						$(".modal-body").html(str)
						$("#btnSave").html("Save Data")
						//$("#btnSave").off('click').on("click", updateCategory)
						$("#btnSave").off('click').on('click',
							function () {
								updateCategory(id)
							})
						$("#modal").modal('show')
					}
				})
			}

			function updateCategory(id) {
				var formdata = '{'
				formdata += '"categoryInitial":"' + $("#categoryInitial").val() + '",'
				formdata += '"categoryName":"' + $("#categoryName").val() + '",'
				formdata += '"isActive":' + $("#isActive")[0].checked + ''
				formdata += '}'

				$.ajax({
					url: '/api/category/edit/' + id,
					data: formdata,
					type: 'put',
					contentType: 'application/json',
					success: function () {
						$("#modal").modal('toggle')
						getAllCategory();
					}
				})
			}

			function f_delete(id) {
				$.ajax({
					url: '/api/category/' + id,
					type: 'get',
					contentType: 'application/json',
					success: function (data) {
						var str = '<h4>Apakah kamu yakin ingin menghapus data ini ?</h4>'
						str += '<center><b> Category Initial</b> : ' + data.categoryInitial + '</center>'
						str += '<center><b> Category Name</b> : ' + data.categoryName + '</center>'

						$(".modal-title").html("Delete Category")
						$(".modal-body").html(str)
						$("#btnSave").off('click').on('click',
							function () {
								deleteCategory(id)
							})
							$("#modal").modal('show')
					}
				})
			}
			function deleteCategory(id){
				$.ajax({
					url: '/api/category/delete/' + id,
					type: 'put',
					contentType: 'application/json',
					success: function(){
						$("#modal").modal('toggle')
						getAllCategory()
					}
				})
			}
		</script>
	</body>
</div>

</html>